diff --git a/usr.sbin/edquota/edquota.c b/usr.sbin/edquota/edquota.c
index 731edf0..7d2b35f 100644
--- a/usr.sbin/edquota/edquota.c
+++ b/usr.sbin/edquota/edquota.c
@@ -329,7 +329,7 @@ getprivs(long id, int quotatype, char *fspath)
 	static int warned = 0;
 
 	setfsent();
-	quphead = (struct quotause *)0;
+	quphead = NULL;
 	qcmd = QCMD(Q_GETQUOTA, quotatype);
 	while ((fs = getfsent())) {
 		if (fspath && *fspath && strcmp(fspath, fs->fs_spec) &&
@@ -452,9 +452,9 @@ editit(char *tmpf)
 		sigsetmask(omask);
 		setgid(getgid());
 		setuid(getuid());
-		if ((ed = getenv("EDITOR")) == (char *)0)
+		if ((ed = getenv("EDITOR")) == NULL)
 			ed = _PATH_VI;
-		execlp(ed, ed, tmpf, (char *)0);
+		execlp(ed, ed, tmpf, NULL);
 		err(1, "%s", ed);
 	}
 	waitpid(pid, &status, 0);
@@ -524,7 +524,7 @@ readprivs(struct quotause *quplist, char *inname)
 			warnx("%s: bad format", line1);
 			return (0);
 		}
-		if ((cp = strtok((char *)0, "\n")) == NULL) {
+		if ((cp = strtok(NULL, "\n")) == NULL) {
 			warnx("%s: %s: bad format", fsp, &fsp[strlen(fsp) + 1]);
 			return (0);
 		}
@@ -657,7 +657,7 @@ readtimes(struct quotause *quplist, char *inname)
 			warnx("%s: bad format", line1);
 			return (0);
 		}
-		if ((cp = strtok((char *)0, "\n")) == NULL) {
+		if ((cp = strtok(NULL, "\n")) == NULL) {
 			warnx("%s: %s: bad format", fsp, &fsp[strlen(fsp) + 1]);
 			return (0);
 		}
diff --git a/usr.sbin/faithd/faithd.c b/usr.sbin/faithd/faithd.c
index 67b5d58..f62a58e 100644
--- a/usr.sbin/faithd/faithd.c
+++ b/usr.sbin/faithd/faithd.c
@@ -768,7 +768,7 @@ sig_child(int sig)
 	int status;
 	pid_t pid;
 
-	pid = wait3(&status, WNOHANG, (struct rusage *)0);
+	pid = wait3(&status, WNOHANG, NULL);
 	if (pid && WEXITSTATUS(status))
 		syslog(LOG_WARNING, "child %d exit status 0x%x", pid, status);
 }
@@ -795,7 +795,7 @@ start_daemon(void)
 	sa.sa_handler = sig_child;
 	sa.sa_flags = SA_NOCLDWAIT;
 	sigemptyset(&sa.sa_mask);
-	sigaction(SIGCHLD, &sa, (struct sigaction *)0);
+	sigaction(SIGCHLD, &sa, NULL);
 #else
 	if (signal(SIGCHLD, sig_child) == SIG_ERR) {
 		exit_failure("signal CHLD: %s", strerror(errno));
diff --git a/usr.sbin/faithd/tcp.c b/usr.sbin/faithd/tcp.c
index 5ace5ff..3093712 100644
--- a/usr.sbin/faithd/tcp.c
+++ b/usr.sbin/faithd/tcp.c
@@ -93,7 +93,7 @@ sig_child(int sig)
 	int status;
 	pid_t pid;
 
-	pid = wait3(&status, WNOHANG, (struct rusage *)0);
+	pid = wait3(&status, WNOHANG, NULL);
 	if (pid && WEXITSTATUS(status))
 		syslog(LOG_WARNING, "child %d exit status 0x%x", pid, status);
 	exit_success("terminate connection due to child termination");
diff --git a/usr.sbin/fdformat/fdformat.c b/usr.sbin/fdformat/fdformat.c
index 79c2416..2a23102 100644
--- a/usr.sbin/fdformat/fdformat.c
+++ b/usr.sbin/fdformat/fdformat.c
@@ -268,7 +268,7 @@ main(int argc, char **argv)
 			break;
 
 		case 'F':	/* fill byte, C-like notation allowed */
-			fill = (int)strtol(optarg, (char **)0, 0);
+			fill = (int)strtol(optarg, NULL, 0);
 			break;
 
 		case 't':	/* steps per track */
diff --git a/usr.sbin/inetd/builtins.c b/usr.sbin/inetd/builtins.c
index 3fc357e..15f9c30 100644
--- a/usr.sbin/inetd/builtins.c
+++ b/usr.sbin/inetd/builtins.c
@@ -741,7 +741,7 @@ getline(int fd, char *buf, int len)
 	sa.sa_flags = 0;
 	sigemptyset(&sa.sa_mask);
 	sa.sa_handler = SIG_DFL;
-	sigaction(SIGALRM, &sa, (struct sigaction *)0);
+	sigaction(SIGALRM, &sa, NULL);
 	do {
 		alarm(10);
 		n = read(fd, buf, len-count);
diff --git a/usr.sbin/inetd/inetd.c b/usr.sbin/inetd/inetd.c
index b746840..969397a 100644
--- a/usr.sbin/inetd/inetd.c
+++ b/usr.sbin/inetd/inetd.c
@@ -538,8 +538,7 @@ main(int argc, char **argv)
 	    }
 #endif
 	    readable = allsock;
-	    if ((n = select(maxsock + 1, &readable, (fd_set *)0,
-		(fd_set *)0, (struct timeval *)0)) <= 0) {
+	    if ((n = select(maxsock + 1, &readable, NULL, NULL, NULL)) <= 0) {
 		    if (n < 0 && errno != EINTR) {
 			syslog(LOG_WARNING, "select: %m");
 			sleep(1);
@@ -585,8 +584,7 @@ main(int argc, char **argv)
 			    i = 1;
 			    if (ioctl(sep->se_fd, FIONBIO, &i) < 0)
 				    syslog(LOG_ERR, "ioctl (FIONBIO, 1): %m");
-			    ctrl = accept(sep->se_fd, (struct sockaddr *)0,
-				(socklen_t *)0);
+			    ctrl = accept(sep->se_fd, NULL, NULL);
 			    if (debug)
 				    warnx("accept, ctrl %d", ctrl);
 			    if (ctrl < 0) {
@@ -698,9 +696,9 @@ main(int argc, char **argv)
 		    sigsetmask(0L);
 		    if (pid == 0) {
 			    if (dofork) {
-				sigaction(SIGALRM, &saalrm, (struct sigaction *)0);
-				sigaction(SIGCHLD, &sachld, (struct sigaction *)0);
-				sigaction(SIGHUP, &sahup, (struct sigaction *)0);
+				sigaction(SIGALRM, &saalrm, NULL);
+				sigaction(SIGCHLD, &sachld, NULL);
+				sigaction(SIGHUP, &sahup, NULL);
 				/* SIGPIPE reset before exec */
 			    }
 			    /*
@@ -835,8 +833,7 @@ main(int argc, char **argv)
 					}
 				}
 #endif
-				sigaction(SIGPIPE, &sapipe,
-				    (struct sigaction *)0);
+				sigaction(SIGPIPE, &sapipe, NULL);
 				execv(sep->se_server, sep->se_argv);
 				syslog(LOG_ERR,
 				    "cannot execute %s: %m", sep->se_server);
@@ -907,7 +904,7 @@ reapchild(void)
 	struct servtab *sep;
 
 	for (;;) {
-		pid = wait3(&status, WNOHANG, (struct rusage *)0);
+		pid = wait3(&status, WNOHANG, NULL);
 		if (pid <= 0)
 			break;
 		if (debug)
@@ -1435,7 +1432,7 @@ enter(struct servtab *cp)
 	long omask;
 
 	sep = (struct servtab *)malloc(sizeof (*sep));
-	if (sep == (struct servtab *)0) {
+	if (sep == NULL) {
 		syslog(LOG_ERR, "malloc: %m");
 		exit(EX_OSERR);
 	}
@@ -1582,7 +1579,7 @@ more:
 		break;
 	}
 	if (cp == NULL)
-		return ((struct servtab *)0);
+		return (NULL);
 	/*
 	 * clear the static buffer, since some fields (se_ctrladdr,
 	 * for example) don't get initialized here.
@@ -1978,8 +1975,8 @@ again:
 		if (c == ' ' || c == '\t')
 			if ((cp = nextline(fconfig)))
 				goto again;
-		*cpp = (char *)0;
-		return ((char *)0);
+		*cpp = NULL;
+		return (NULL);
 	}
 	if (*cp == '"' || *cp == '\'')
 		quote = *cp++;
@@ -2002,7 +1999,7 @@ nextline(FILE *fd)
 	char *cp;
 
 	if (fgets(line, sizeof (line), fd) == NULL)
-		return ((char *)0);
+		return (NULL);
 	cp = strchr(line, '\n');
 	if (cp)
 		*cp = '\0';
diff --git a/usr.sbin/lpr/common_source/common.c b/usr.sbin/lpr/common_source/common.c
index 6246974..3b56a6d 100644
--- a/usr.sbin/lpr/common_source/common.c
+++ b/usr.sbin/lpr/common_source/common.c
@@ -212,11 +212,11 @@ delay(int millisec)
 	struct timeval tdelay;
 
 	if (millisec <= 0 || millisec > 10000)
-		fatal((struct printer *)0, /* fatal() knows how to deal */
+		fatal(NULL, /* fatal() knows how to deal */
 		    "unreasonable delay period (%d)", millisec);
 	tdelay.tv_sec = millisec / 1000;
 	tdelay.tv_usec = millisec * 1000 % 1000000;
-	select(0, (fd_set *)0, (fd_set *)0, (fd_set *)0, &tdelay);
+	select(0, NULL, NULL, NULL, &tdelay);
 }
 
 char *
diff --git a/usr.sbin/lpr/common_source/startdaemon.c b/usr.sbin/lpr/common_source/startdaemon.c
index 962b98f..13d5da6 100644
--- a/usr.sbin/lpr/common_source/startdaemon.c
+++ b/usr.sbin/lpr/common_source/startdaemon.c
@@ -87,7 +87,7 @@ startdaemon(const struct printer *pp)
 	 * Avoid overruns without putting artificial limitations on 
 	 * the length.
 	 */
-	if (writel(s, "\1", pp->printer, "\n", (char *)0) <= 0) {
+	if (writel(s, "\1", pp->printer, "\n", NULL) <= 0) {
 		warn("write");
 		close(s);
 		return(0);
diff --git a/usr.sbin/lpr/lpc/lpc.c b/usr.sbin/lpr/lpc/lpc.c
index 023786f..b13e170 100644
--- a/usr.sbin/lpr/lpc/lpc.c
+++ b/usr.sbin/lpr/lpc/lpc.c
@@ -331,7 +331,7 @@ help(int argc, char **argv)
 		c = getcmd(arg);
 		if (c == (struct cmd *)-1)
 			printf("?Ambiguous help command %s\n", arg);
-		else if (c == (struct cmd *)0)
+		else if (c == NULL)
 			printf("?Invalid help command %s\n", arg);
 		else
 			printf("%-*s\t%s\n", (int) HELPINDENT,
diff --git a/usr.sbin/lpr/lpd/lpd.c b/usr.sbin/lpr/lpd/lpd.c
index b9e9f37..4e1eb85 100644
--- a/usr.sbin/lpr/lpd/lpd.c
+++ b/usr.sbin/lpr/lpd/lpd.c
@@ -245,7 +245,7 @@ main(int argc, char **argv)
 		if (pid < 0) {
 			err(EX_OSERR, "cannot fork");
 		} else if (pid == 0) {	/* child */
-			execl(_PATH_CHKPRINTCAP, _PATH_CHKPRINTCAP, (char *)0);
+			execl(_PATH_CHKPRINTCAP, _PATH_CHKPRINTCAP, NULL);
 			err(EX_OSERR, "cannot execute %s", _PATH_CHKPRINTCAP);
 		}
 		if (waitpid(pid, &status, 0) < 0) {
@@ -328,7 +328,7 @@ main(int argc, char **argv)
 		exit(1);
 	}
 	umask(0);
-	sigprocmask(SIG_SETMASK, &omask, (sigset_t *)0);
+	sigprocmask(SIG_SETMASK, &omask, NULL);
 	FD_ZERO(&defreadfds);
 	FD_SET(funix, &defreadfds);
 	listen(funix, 5);
diff --git a/usr.sbin/lpr/lpd/printjob.c b/usr.sbin/lpr/lpd/printjob.c
index a43f547..cbb2a86 100644
--- a/usr.sbin/lpr/lpd/printjob.c
+++ b/usr.sbin/lpr/lpd/printjob.c
@@ -660,7 +660,7 @@ print(struct printer *pp, int format, char *file)
 			execl(_PATH_PR, "pr", width, length,
 			    "-h", *title ? title : " ",
 			    "-L", *locale ? locale : "C",
-			    "-F", (char *)0);
+			    "-F", NULL);
 			syslog(LOG_ERR, "cannot execl %s", _PATH_PR);
 			exit(2);
 		}
@@ -1434,7 +1434,7 @@ sendmail(struct printer *pp, char *userid, int bombed)
 			cp++;
 		else
 			cp = _PATH_SENDMAIL;
-		execl(_PATH_SENDMAIL, cp, "-t", (char *)0);
+		execl(_PATH_SENDMAIL, cp, "-t", NULL);
 		_exit(0);
 	} else if (s > 0) {				/* parent */
 		dup2(p[1], 1);
@@ -1680,7 +1680,7 @@ openpr(const struct printer *pp)
 			else
 				cp++;
 			execl(pp->filters[LPF_OUTPUT], cp, width, length,
-			      (char *)0);
+			      NULL);
 			syslog(LOG_ERR, "%s: execl(%s): %m", pp->printer,
 			    pp->filters[LPF_OUTPUT]);
 			exit(1);
@@ -1793,8 +1793,7 @@ openrem(const struct printer *pp)
 		alarm(0);
 		signal(SIGALRM, savealrm);
 		if (pfd >= 0) {
-			if ((writel(pfd, "\2", pp->remote_queue, "\n", 
-				    (char *)0)
+			if ((writel(pfd, "\2", pp->remote_queue, "\n", NULL)
 			     == 2 + strlen(pp->remote_queue))
 			    && (resp = response(pp)) == 0)
 				break;
@@ -1824,7 +1823,7 @@ setty(const struct printer *pp)
 {
 	struct termios ttybuf;
 
-	if (ioctl(pfd, TIOCEXCL, (char *)0) < 0) {
+	if (ioctl(pfd, TIOCEXCL, NULL) < 0) {
 		syslog(LOG_ERR, "%s: ioctl(TIOCEXCL): %m", pp->printer);
 		exit(1);
 	}
@@ -1868,7 +1867,7 @@ pstatus(const struct printer *pp, const char *msg, ...)
 	ftruncate(fd, 0);
 	vasprintf(&buf, msg, ap);
 	va_end(ap);
-	writel(fd, buf, "\n", (char *)0);
+	writel(fd, buf, "\n", NULL);
 	close(fd);
 	free(buf);
 }
diff --git a/usr.sbin/mrouted/main.c b/usr.sbin/mrouted/main.c
index 24b9321..1e61d1f 100644
--- a/usr.sbin/mrouted/main.c
+++ b/usr.sbin/mrouted/main.c
@@ -385,7 +385,7 @@ main(int argc, char **argv)
 #ifdef TIOCNOTTY
 	t = open(_PATH_TTY, 2);
 	if (t >= 0) {
-	    ioctl(t, TIOCNOTTY, (char *)0);
+	    ioctl(t, TIOCNOTTY, NULL);
 	    close(t);
 	}
 #else
diff --git a/usr.sbin/mrouted/mtrace.c b/usr.sbin/mrouted/mtrace.c
index 6015723..b096d0a 100644
--- a/usr.sbin/mrouted/mtrace.c
+++ b/usr.sbin/mrouted/mtrace.c
@@ -743,7 +743,7 @@ inet_name(u_int32 addr)
 u_int32 
 host_addr(char *name)
 {
-    struct hostent *e = (struct hostent *)0;
+    struct hostent *e = NULL;
     u_int32  addr;
     int	i, dots = 3;
     char	buf[40];
@@ -1231,8 +1231,7 @@ send_recv(u_int32 dst, int type, int code, int tries, struct resp_buf *save,
 	    if (tv.tv_usec < 0) tv.tv_usec += 1000000L, --tv.tv_sec;
 	    if (tv.tv_sec < 0) tv.tv_sec = tv.tv_usec = 0;
 
-	    count = select(igmp_socket + 1, &fds, (fd_set *)0, (fd_set *)0,
-			   &tv);
+	    count = select(igmp_socket + 1, &fds, NULL, NULL, &tv);
 
 	    if (count < 0) {
 		if (errno != EINTR) warn("select");
diff --git a/usr.sbin/newsyslog/newsyslog.c b/usr.sbin/newsyslog/newsyslog.c
index e4810e3..5dff303 100644
--- a/usr.sbin/newsyslog/newsyslog.c
+++ b/usr.sbin/newsyslog/newsyslog.c
@@ -1637,7 +1637,7 @@ do_zipwork(struct zipwork_entry *zwork)
 	}
 	if (!pidzip) {
 		/* The child process executes the compression command */
-		execl(pgm_path, pgm_path, "-f", zwork->zw_fname, (char *)0);
+		execl(pgm_path, pgm_path, "-f", zwork->zw_fname, NULL);
 		err(1, "execl(`%s -f %s')", pgm_path, zwork->zw_fname);
 	}
 
diff --git a/usr.sbin/pciconf/pciconf.c b/usr.sbin/pciconf/pciconf.c
index 6061e97..901bbc0 100644
--- a/usr.sbin/pciconf/pciconf.c
+++ b/usr.sbin/pciconf/pciconf.c
@@ -529,9 +529,9 @@ writeit(const char *name, const char *reg, const char *data, int width)
 	struct pci_io pi;
 
 	pi.pi_sel = getsel(name);
-	pi.pi_reg = strtoul(reg, (char **)0, 0); /* XXX error check */
+	pi.pi_reg = strtoul(reg, NULL, 0); /* XXX error check */
 	pi.pi_width = width;
-	pi.pi_data = strtoul(data, (char **)0, 0); /* XXX error check */
+	pi.pi_data = strtoul(data, NULL, 0); /* XXX error check */
 
 	fd = open(_PATH_DEVPCI, O_RDWR, 0);
 	if (fd < 0)
diff --git a/usr.sbin/pppd/main.c b/usr.sbin/pppd/main.c
index d4c29d6..4181e8a 100644
--- a/usr.sbin/pppd/main.c
+++ b/usr.sbin/pppd/main.c
@@ -1121,7 +1121,7 @@ device_script(char *program, int in, int out)
 	}
 	setuid(getuid());
 	setgid(getgid());
-	execl("/bin/sh", "sh", "-c", program, (char *)0);
+	execl("/bin/sh", "sh", "-c", program, NULL);
 	syslog(LOG_ERR, "could not exec /bin/sh: %m");
 	_exit(99);
 	/* NOTREACHED */
diff --git a/usr.sbin/repquota/repquota.c b/usr.sbin/repquota/repquota.c
index aa24251..eca451a 100644
--- a/usr.sbin/repquota/repquota.c
+++ b/usr.sbin/repquota/repquota.c
@@ -212,7 +212,7 @@ repquota(struct fstab *fs, int type, char *qfpathname)
 		if (dqbuf.dqb_curinodes == 0 && dqbuf.dqb_curblocks == 0)
 			continue;
 		if ((fup = lookup(id, type)) == 0)
-			fup = addid(id, type, (char *)0);
+			fup = addid(id, type, NULL);
 		fup->fu_dqblk = dqbuf;
 	}
 	fclose(qf);
@@ -318,7 +318,7 @@ lookup(u_long id, int type)
 	for (fup = fuhead[type][id & (FUHASH-1)]; fup != 0; fup = fup->fu_next)
 		if (fup->fu_id == id)
 			return (fup);
-	return ((struct fileusage *)0);
+	return (NULL);
 }
 
 /*
diff --git a/usr.sbin/rmt/rmt.c b/usr.sbin/rmt/rmt.c
index 93cecf7..c049729 100644
--- a/usr.sbin/rmt/rmt.c
+++ b/usr.sbin/rmt/rmt.c
@@ -82,7 +82,7 @@ main(int argc, char **argv)
 		debug = fopen(*argv, "w");
 		if (debug == 0)
 			exit(1);
-		setbuf(debug, (char *)0);
+		setbuf(debug, NULL);
 	}
 top:
 	errno = 0;
diff --git a/usr.sbin/rpc.statd/statd.c b/usr.sbin/rpc.statd/statd.c
index 015d3d8..c7dc147 100644
--- a/usr.sbin/rpc.statd/statd.c
+++ b/usr.sbin/rpc.statd/statd.c
@@ -126,7 +126,7 @@ static void
 handle_sigchld(int sig, int code, struct sigcontext *scp)
 {
   int pid, status;
-  pid = wait4(-1, &status, WNOHANG, (struct rusage*)0);
+  pid = wait4(-1, &status, WNOHANG, NULL);
   if (!pid) syslog(LOG_ERR, "Phantom SIGCHLD??");
   else if (status == 0)
   {
diff --git a/usr.sbin/rpc.ypupdated/ypupdated_main.c b/usr.sbin/rpc.ypupdated/ypupdated_main.c
index 7784e61..4007aeb 100644
--- a/usr.sbin/rpc.ypupdated/ypupdated_main.c
+++ b/usr.sbin/rpc.ypupdated/ypupdated_main.c
@@ -138,8 +138,7 @@ ypupdated_svc_run(void)
 #else
 		readfds = svc_fds;
 #endif /* def FD_SETSIZE */
-		switch (select(fd_setsize, &readfds, NULL, NULL,
-			       (struct timeval *)0)) {
+		switch (select(fd_setsize, &readfds, NULL, NULL, NULL)) {
 		case -1:
 			if (errno == EINTR) {
 				continue;
diff --git a/usr.sbin/rpc.ypxfrd/ypxfrd_main.c b/usr.sbin/rpc.ypxfrd/ypxfrd_main.c
index bf32956..e5aec86 100644
--- a/usr.sbin/rpc.ypxfrd/ypxfrd_main.c
+++ b/usr.sbin/rpc.ypxfrd/ypxfrd_main.c
@@ -139,8 +139,7 @@ ypxfrd_svc_run(void)
 #else
 		readfds = svc_fds;
 #endif /* def FD_SETSIZE */
-		switch (select(fd_setsize, &readfds, NULL, NULL,
-			       (struct timeval *)0)) {
+		switch (select(fd_setsize, &readfds, NULL, NULL, NULL)) {
 		case -1:
 			if (errno == EINTR) {
 				continue;
diff --git a/usr.sbin/timed/timed/master.c b/usr.sbin/timed/timed/master.c
index e344f1a..d19cc1e 100644
--- a/usr.sbin/timed/timed/master.c
+++ b/usr.sbin/timed/timed/master.c
@@ -286,7 +286,7 @@ loop:
 			 * do not want to call synch() while waiting
 			 * to be killed!
 			 */
-			gettimeofday(&ntime, (struct timezone *)0);
+			gettimeofday(&ntime, NULL);
 			pollingtime = ntime.tv_sec + SAMPLEINTVL;
 			break;
 
diff --git a/usr.sbin/timed/timed/measure.c b/usr.sbin/timed/timed/measure.c
index da20aa7..614f5ef 100644
--- a/usr.sbin/timed/timed/measure.c
+++ b/usr.sbin/timed/timed/measure.c
@@ -170,9 +170,8 @@ measure(u_long maxmsec,			/* wait this many msec at most */
 				tout.tv_sec = 0;
 
 			FD_SET(sock_raw, &ready);
-			count = select(sock_raw+1, &ready, (fd_set *)0,
-				       (fd_set *)0, &tout);
-			gettimeofday(&tcur, (struct timezone *)0);
+			count = select(sock_raw+1, &ready, NULL, NULL, &tout);
+			gettimeofday(&tcur, NULL);
 			if (count <= 0)
 				break;
 
diff --git a/usr.sbin/timed/timed/readmsg.c b/usr.sbin/timed/timed/readmsg.c
index f2b1854..e0698d4 100644
--- a/usr.sbin/timed/timed/readmsg.c
+++ b/usr.sbin/timed/timed/readmsg.c
@@ -193,8 +193,7 @@ again:
 		}
 
 		FD_SET(sock, &ready);
-		if (!select(sock+1, &ready, (fd_set *)0, (fd_set *)0,
-			   &rwait)) {
+		if (!select(sock+1, &ready, NULL, NULL, &rwait)) {
 			if (rwait.tv_sec == 0 && rwait.tv_usec == 0)
 				return(0);
 			continue;
@@ -217,7 +216,7 @@ again:
 			      inet_ntoa(from.sin_addr));
 			continue;
 		}
-		gettimeofday(&from_when, (struct timezone *)0);
+		gettimeofday(&from_when, NULL);
 		bytehostorder(&msgin);
 
 		if (msgin.tsp_vers > TSPVERSION) {
diff --git a/usr.sbin/timed/timed/slave.c b/usr.sbin/timed/timed/slave.c
index ecdd74f..9399502 100644
--- a/usr.sbin/timed/timed/slave.c
+++ b/usr.sbin/timed/timed/slave.c
@@ -100,7 +100,7 @@ slave(void)
 
 loop:
 	get_goodgroup(0);
-	gettimeofday(&ntime, (struct timezone *)0);
+	gettimeofday(&ntime, NULL);
 	if (ntime.tv_sec > electiontime) {
 		if (trace)
 			fprintf(fd, "election timer expired\n");
diff --git a/usr.sbin/timed/timed/timed.c b/usr.sbin/timed/timed/timed.c
index 172fa6f..2c13276 100644
--- a/usr.sbin/timed/timed/timed.c
+++ b/usr.sbin/timed/timed/timed.c
@@ -228,7 +228,7 @@ main(int argc, char *argv[])
 	/* rounds kernel variable time to multiple of 5 ms. */
 	ntime.tv_sec = 0;
 	ntime.tv_usec = -((ntime.tv_usec/1000) % 5) * 1000;
-	adjtime(&ntime, (struct timeval *)0);
+	adjtime(&ntime, NULL);
 
 	for (nt = nets; nt; nt = nt->next) {
 		nentp = getnetbyname(nt->name);
@@ -690,7 +690,7 @@ date(void)
 	struct	timeval tv;
 	time_t	tv_sec;
 
-	gettimeofday(&tv, (struct timezone *)0);
+	gettimeofday(&tv, NULL);
 	tv_sec = tv.tv_sec;
 	return (ctime(&tv_sec));
 }
diff --git a/usr.sbin/timed/timedc/cmds.c b/usr.sbin/timed/timedc/cmds.c
index 1376fc6..69d2a5c 100644
--- a/usr.sbin/timed/timedc/cmds.c
+++ b/usr.sbin/timed/timedc/cmds.c
@@ -105,8 +105,7 @@ daydiff(char *hostname)
 		for (;;) {
 			FD_ZERO(&ready);
 			FD_SET(sock, &ready);
-			i = select(sock+1, &ready, (fd_set *)0,
-				   (fd_set *)0, &tout);
+			i = select(sock+1, &ready, NULL, NULL, &tout);
 			if (i < 0) {
 				if (errno == EINTR)
 					continue;
@@ -131,7 +130,7 @@ daydiff(char *hostname)
 			}
 			sec -= BU;
 
-			gettimeofday(&now, (struct timezone*)0);
+			gettimeofday(&now, NULL);
 			return (sec - now.tv_sec);
 		}
 	}
@@ -313,8 +312,7 @@ msite(int argc, char *argv[])
 		tout.tv_usec = 0;
 		FD_ZERO(&ready);
 		FD_SET(sock, &ready);
-		if (select(FD_SETSIZE, &ready, (fd_set *)0, (fd_set *)0,
-			   &tout)) {
+		if (select(FD_SETSIZE, &ready, NULL, NULL, &tout)) {
 			length = sizeof(from);
 			cc = recvfrom(sock, &msg, sizeof(struct tsp), 0,
 				      (struct sockaddr *)&from, &length);
@@ -468,7 +466,7 @@ tracing(int argc, char *argv[])
 	tout.tv_usec = 0;
 	FD_ZERO(&ready);
 	FD_SET(sock, &ready);
-	if (select(FD_SETSIZE, &ready, (fd_set *)0, (fd_set *)0, &tout)) {
+	if (select(FD_SETSIZE, &ready, NULL, NULL, &tout)) {
 		length = sizeof(from);
 		cc = recvfrom(sock, &msg, sizeof(struct tsp), 0,
 			      (struct sockaddr *)&from, &length);
diff --git a/usr.sbin/timed/timedc/timedc.c b/usr.sbin/timed/timedc/timedc.c
index d9a39e4..94ae45c 100644
--- a/usr.sbin/timed/timedc/timedc.c
+++ b/usr.sbin/timed/timedc/timedc.c
@@ -236,7 +236,7 @@ help(int argc, char **argv)
 		c = getcmd(arg);
 		if (c == (struct cmd *)-1)
 			printf("?Ambiguous help command %s\n", arg);
-		else if (c == (struct cmd *)0)
+		else if (c == NULL)
 			printf("?Invalid help command %s\n", arg);
 		else
 			printf("%-*s\t%s\n", (int)HELPINDENT,
diff --git a/usr.sbin/traceroute/traceroute.c b/usr.sbin/traceroute/traceroute.c
index 6694471..13eff5c 100644
--- a/usr.sbin/traceroute/traceroute.c
+++ b/usr.sbin/traceroute/traceroute.c
@@ -755,7 +755,7 @@ wait_for_reply(int sock, struct sockaddr_in *from, struct timeval *sent)
 	if (wait.tv_sec < 0)
 		wait.tv_sec = wait.tv_usec = 0;
 
-	if (select(sock+1, fdsp, (fd_set *)0, (fd_set *)0, &wait) > 0)
+	if (select(sock+1, fdsp, NULL, NULL, &wait) > 0)
 		cc = recvfrom(s, (char *)packet, sizeof(packet), 0,
 		    (struct sockaddr *)from, &fromlen);
 
diff --git a/usr.sbin/traceroute6/traceroute6.c b/usr.sbin/traceroute6/traceroute6.c
index 57ae5b1..8ae3cdb 100644
--- a/usr.sbin/traceroute6/traceroute6.c
+++ b/usr.sbin/traceroute6/traceroute6.c
@@ -914,7 +914,7 @@ wait_for_reply(int sock, struct msghdr *mhdr)
 	FD_SET(sock, fdsp);
 	wait.tv_sec = waittime; wait.tv_usec = 0;
 
-	if (select(sock+1, fdsp, (fd_set *)0, (fd_set *)0, &wait) > 0)
+	if (select(sock+1, fdsp, NULL, NULL, &wait) > 0)
 		cc = recvmsg(rcvsock, mhdr, 0);
 
 	free(fdsp);
